Index: src/org/jboss/tools/internal/deltacloud/test/fakes/APIResponseFakes.java
===================================================================
--- src/org/jboss/tools/internal/deltacloud/test/fakes/APIResponseFakes.java	(revision 0)
+++ src/org/jboss/tools/internal/deltacloud/test/fakes/APIResponseFakes.java	(revision 0)
@@ -0,0 +1,56 @@
+/*******************************************************************************
+ * Copyright (c) 2010 Red Hat, Inc.
+ * Distributed under license by Red Hat, Inc. All rights reserved.
+ * This program is made available under the terms of the
+ * Eclipse Public License v1.0 which accompanies this distribution,
+ * and is available at http://www.eclipse.org/legal/epl-v10.html
+ *
+ * Contributors:
+ *     Red Hat, Inc. - initial API and implementation
+ ******************************************************************************/
+package org.jboss.tools.internal.deltacloud.test.fakes;
+
+/**
+ * @author André Dietisheim
+ */
+public class APIResponseFakes {
+
+	public static class APIResponse {
+		public static final String url = "http://localhost:3001/api/keys/test1292840175447";
+		public static final String driver = "ec2";
+
+		public static final String apiResponse = getApiResponseXML(url, driver);
+		public static final String invalidDriverApiResponse = getApiResponseXML(url, "foo");
+	}
+
+	private static final String getApiResponseXML(String url, String driver) {
+		return "<api driver='" + driver + "' version='0.1'>"
+				+ "  <link href='" + url + "realms' rel='realms'>"
+				+ "  </link>"
+				+ "  <link href='" + url + "images' rel='images'>"
+				+ "    <feature name='owner_id'></feature>"
+				+ "  </link>"
+				+ "  <link href='" + url + "instance_states' rel='instance_states'>"
+				+ "  </link>"
+				+ "  <link href='" + url + "instances' rel='instances'>"
+				+ "    <feature name='user_data'></feature>"
+				+ "    <feature name='authentication_key'></feature>"
+				+ "    <feature name='public_ip'></feature>"
+				+ "    <feature name='security_group'></feature>"
+				+ "  </link>"
+				+ "  <link href='" + url + "hardware_profiles' rel='hardware_profiles'>"
+				+ "  </link>"
+				+ "  <link href='" + url + "storage_snapshots' rel='storage_snapshots'>"
+				+ "  </link>"
+				+ "  <link href='" + url + "storage_volumes' rel='storage_volumes'>"
+				+ "  </link>"
+				+ "  <link href='" + url + "keys' rel='keys'>"
+				+ "  </link>"
+				+ "  <link href='" + url + "buckets' rel='buckets'>"
+				+ "    <feature name='bucket_location'></feature>"
+				+ "  </link>"
+				+ "</api>";
+
+	}
+
+}
Index: src/org/jboss/tools/internal/deltacloud/test/core/client/APIDomUnmarshallingTest.java
===================================================================
--- src/org/jboss/tools/internal/deltacloud/test/core/client/APIDomUnmarshallingTest.java	(revision 0)
+++ src/org/jboss/tools/internal/deltacloud/test/core/client/APIDomUnmarshallingTest.java	(revision 0)
@@ -0,0 +1,48 @@
+/*******************************************************************************
+ * Copyright (c) 2010 Red Hat, Inc.
+ * Distributed under license by Red Hat, Inc. All rights reserved.
+ * This program is made available under the terms of the
+ * Eclipse Public License v1.0 which accompanies this distribution,
+ * and is available at http://www.eclipse.org/legal/epl-v10.html
+ *
+ * Contributors:
+ *     Red Hat, Inc. - initial API and implementation
+ ******************************************************************************/
+package org.jboss.tools.internal.deltacloud.test.core.client;
+
+import static org.junit.Assert.assertEquals;
+import static org.junit.Assert.assertNotNull;
+
+import java.io.ByteArrayInputStream;
+import java.net.MalformedURLException;
+
+import org.jboss.tools.deltacloud.core.client.API;
+import org.jboss.tools.deltacloud.core.client.DeltaCloudClientException;
+import org.jboss.tools.deltacloud.core.client.API.Driver;
+import org.jboss.tools.deltacloud.core.client.unmarshal.APIUnmarshaller;
+import org.jboss.tools.internal.deltacloud.test.fakes.APIResponseFakes.APIResponse;
+import org.junit.Test;
+
+/**
+ * @author André Dietisheim
+ */
+public class APIDomUnmarshallingTest {
+
+	@Test
+	public void ec2DriverIsUnmarshalled() throws MalformedURLException, DeltaCloudClientException {
+		API api = new API();
+		ByteArrayInputStream inputStream = new ByteArrayInputStream(APIResponse.apiResponse.getBytes());
+		new APIUnmarshaller().unmarshall(inputStream, api);
+		assertNotNull(api);
+		assertEquals(APIResponse.driver, api.getDriver().name().toLowerCase());
+	}
+
+	@Test
+	public void invalidDriverUnmarshalledToUnknown() throws MalformedURLException, DeltaCloudClientException {
+		API api = new API();
+		ByteArrayInputStream inputStream = new ByteArrayInputStream(APIResponse.invalidDriverApiResponse.getBytes());
+		new APIUnmarshaller().unmarshall(inputStream, api);
+		assertNotNull(api);
+		assertEquals(Driver.UNKNOWN, api.getDriver());
+	}
+}
Index: src/org/jboss/tools/internal/deltacloud/test/fakes/InstanceResponseFakes.java
===================================================================
--- src/org/jboss/tools/internal/deltacloud/test/fakes/InstanceResponseFakes.java	(revision 29180)
+++ src/org/jboss/tools/internal/deltacloud/test/fakes/InstanceResponseFakes.java	(working copy)
@@ -10,7 +10,7 @@
  ******************************************************************************/
 package org.jboss.tools.internal.deltacloud.test.fakes;
 
-import org.jboss.tools.deltacloud.core.client.Instance.InstanceState;
+import org.jboss.tools.deltacloud.core.client.StateAware.State;
 
 /**
  * @author André Dietisheim
@@ -33,7 +33,7 @@
 		public static final String image1Id = "ami-7d07ec14";
 		public static final String realm1Url = "http://try.steamcannon.org/deltacloud/api/realms/us-east-1a";
 		public static final String realm1Id = "us-east-1a";
-		public static final InstanceState state = InstanceState.RUNNING;
+		public static final State state = State.RUNNING;
 		public static final String hardwareProfile1Url = "http://try.steamcannon.org/deltacloud/api/hardware_profiles/m1.small";
 		public static final String hardwareProfile1Id = "m1.small";
 		public static final String keyname1 = "ad10";
@@ -57,7 +57,7 @@
 		public static final String image1Id = "ami-7d07ec14";
 		public static final String realm1Url = "http://try.steamcannon.org/deltacloud/api/realms/us-east-1a";
 		public static final String realm1Id = "us-east-1a";
-		public static final InstanceState state = InstanceState.RUNNING;
+		public static final State state = State.RUNNING;
 		public static final String hardwareProfile1Url = "http://try.steamcannon.org/deltacloud/api/hardware_profiles/m1.small";
 		public static final String hardwareProfile1Id = "m1.small";
 		public static final String keyname1 = "ad10";
@@ -74,7 +74,7 @@
 		public static final String image2Id = "ami-7d07ec14";
 		public static final String realm2Url = "http://try.steamcannon.org/deltacloud/api/realms/us-east-2a";
 		public static final String realm2Id = "us-east-2a";
-		public static final InstanceState state2 = InstanceState.STOPPED;
+		public static final State state2 = State.STOPPED;
 		public static final String hardwareProfile2Url = "http://try.steamcannon.org/deltacloud/api/hardware_profiles/m1.large";
 		public static final String hardwareProfile2Id = "m1.large";
 		public static final String keyname2 = "ad11";
@@ -96,7 +96,7 @@
 	}
 
 	private static final String getInstanceResponseXML(String url, String id, String name, String owner,
-			String imageUrl, String imageId, String realmUrl, String realmId, InstanceState state,
+			String imageUrl, String imageId, String realmUrl, String realmId, State state,
 			String hardwareProfileUrl, String hardwareProfileId, String keyname, String actionName1,
 			String actionName2, String publicAddress, String privateAddress) {
 		return "<instance href=\""
Index: src/org/jboss/tools/internal/deltacloud/test/context/MockIntegrationTestContext.java
===================================================================
--- src/org/jboss/tools/internal/deltacloud/test/context/MockIntegrationTestContext.java	(revision 29180)
+++ src/org/jboss/tools/internal/deltacloud/test/context/MockIntegrationTestContext.java	(working copy)
@@ -24,12 +24,12 @@
 import java.util.concurrent.ExecutorService;
 import java.util.concurrent.Executors;
 
-import org.jboss.tools.deltacloud.core.client.DeltaCloudClientImpl;
-import org.jboss.tools.deltacloud.core.client.DeltaCloudClientException;
 import org.jboss.tools.deltacloud.core.client.DeltaCloudClient;
+import org.jboss.tools.deltacloud.core.client.DeltaCloudClientException;
+import org.jboss.tools.deltacloud.core.client.DeltaCloudClientImpl;
 import org.jboss.tools.deltacloud.core.client.Image;
 import org.jboss.tools.deltacloud.core.client.Instance;
-import org.jboss.tools.deltacloud.core.client.Instance.InstanceState;
+import org.jboss.tools.deltacloud.core.client.StateAware.State;
 
 /**
  * A class that holds the integration test context
@@ -103,7 +103,7 @@
 	public void quietlyDestroyInstance(Instance instance) {
 		if (instance != null) {
 			try {
-				if (instance.getState() == Instance.InstanceState.RUNNING) {
+				if (instance.getState() == Instance.State.RUNNING) {
 					instance.stop(client);
 				}
 				instance.destroy(client);
@@ -127,7 +127,7 @@
 	 * @throws ExecutionException
 	 * @throws InterruptedException
 	 */
-	public boolean waitForInstanceState(final String instanceId, final InstanceState state, final long timeout)
+	public boolean waitForInstanceState(final String instanceId, final State state, final long timeout)
 			throws InterruptedException, ExecutionException {
 		final long startTime = System.currentTimeMillis();
 		Callable<Boolean> waitingCallable = new Callable<Boolean>() {
